/* This file is part of the iox-ili project.
 * For more information, please see <http://www.eisenhutinformatik.ch/iox-ili/>.
 *
 * Copyright (c) 2006 Eisenhut Informatik AG
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included 
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 */

package ch.interlis.iom_j;
	
import java.util.HashMap;
import java.util.Iterator;
import java.util.ArrayList;
	/** This class provides a default implementation for the IomObject interface.
	 * @author ceis
	 */
	public class Iom_jObject implements ch.interlis.iom.IomObject, java.io.Serializable
	{
		// HashMap<string attrname,ArrayList<string|iomObject>>
		private HashMap attrv = new HashMap();

		/** creates a new object. Do not use this function, unless you know what you do.
		 * Applications should use the factory method of the reader or writer.
		 * @param tag1 type of new object.
		 * @param oid1 oid of new object. May be null in case of a structure.
		 */
		public Iom_jObject(String tag1, String oid1)
		{
            tag = tag1;
            oid = oid1;
		}
		/** @deprecated
		 */
		public ch.interlis.iom.IomObject addattrobj(
			String attrName,
			String type) {
				Iom_jObject ret = null;
				if (attrv.containsKey(attrName))
				{
					// found, add
					ArrayList valuev = (ArrayList)attrv.get(attrName);
					ret = new Iom_jObject(type, null);
					valuev.add(ret);
				}
				else
				{
					// not found, add
					ArrayList valuev = new ArrayList();
					ret = new Iom_jObject(type, null);
					valuev.add(ret);
					attrv.put(attrName, valuev);
				}
				return ret;
		}
		public void addattrobj(
			String attrName,
			ch.interlis.iom.IomObject obj) {
				if(obj==null){
					throw new IllegalArgumentException("illegal argument obj (=null)");
				}
				if (attrv.containsKey(attrName))
				{
					// found, add
					ArrayList valuev = (ArrayList)attrv.get(attrName);
					valuev.add(obj);
				}
				else
				{
					// not found, add
					ArrayList valuev = new ArrayList();
					valuev.add(obj);
					attrv.put(attrName, valuev);
				}
		}

		/** @deprecated
		 */
		public ch.interlis.iom.IomObject changeattrobj(
			String attrName,
			int index,
			String type) {
				Iom_jObject ret = null;
				if (attrv.containsKey(attrName))
				{
					// found, change
					ArrayList valuev = (ArrayList)attrv.get(attrName);
					ret = new Iom_jObject(type, null);
					valuev.set(index,ret);
				}
				else
				{
					// not found, add
					ArrayList valuev = new ArrayList();
					ret = new Iom_jObject(type, null);
					valuev.set(index,ret);
					attrv.put(attrName, valuev);
				}
				return ret;
		}
		public void changeattrobj(
			String attrName,
			int index,
			ch.interlis.iom.IomObject obj) {
			if(obj==null){
				throw new IllegalArgumentException("illegal argument obj (=null)");
			}
				if (attrv.containsKey(attrName))
				{
					// found, change
					ArrayList valuev = (ArrayList)attrv.get(attrName);
					valuev.set(index,obj);
				}
				else
				{
					// not found, add
					ArrayList valuev = new ArrayList();
					valuev.set(index,obj);
					attrv.put(attrName, valuev);
				}
		}

		public void delete() {
		}
		public void deleteattrobj(String attrName, int index) {
			if (attrv.containsKey(attrName))
			{
				// found, remove
				ArrayList valuev = (ArrayList)attrv.get(attrName);
				if (index>=0 && index<valuev.size())
				{
					valuev.remove(index);
				}
			}
			else
			{
				// not found, nothing to do
			}
		}

		public int getattrcount() {
			return attrv.size();
		}

		public String getattrname(int index) {
			int i=0;
			for(Iterator attri=attrv.keySet().iterator();attri.hasNext();)
			{
				String attr=(String)attri.next();
				if (i == index)
				{
					return attr;
				}
				i++;
			}
			return null;
		}

		public ch.interlis.iom.IomObject getattrobj(
			String attrName,
			int index) {
				if (attrv.containsKey(attrName))
				{
					ArrayList valuev = (ArrayList)attrv.get(attrName);
					Object val = valuev.get(index);
					if (val instanceof Iom_jObject)
					{
						return (Iom_jObject)val;
					}
				}
				return null;
		}

		public String getattrprim(String attrName, int index) 
		{
			if (attrv.containsKey(attrName))
			{
				ArrayList valuev = (ArrayList)attrv.get(attrName);
				Object val=valuev.get(index);
				if(val instanceof String){
					return (String)val;
				}
			}
			return null;
		}

		public String getattrvalue(String attrName) {
			if (attrv.containsKey(attrName))
			{
				ArrayList valuev = (ArrayList)attrv.get(attrName);
				Object val = valuev.get(0);
				if (val instanceof String)
				{
					return (String)val;
				}
			}
			return null;
		}

		public int getattrvaluecount(String attrName) {
			if (attrv.containsKey(attrName))
			{
				ArrayList valuev = (ArrayList)attrv.get(attrName);
				return valuev.size();
			}
			return 0;
		}
		private int col=0;
		public int getobjectcol() {
			return col;
		}
		private int line=0;
		public int getobjectline() {
			return line;
		}
		public void setobjectcol(int col) {
			this.col=col;
		}

		public void setobjectline(int line) {
			this.line=line;
		}
		public String getxmleleattrname(int index) {
			return null;
		}

		public int getxmlelecount() {
			return 0;
		}

		public ch.interlis.iom.IomObject getxmleleobj(int index) {
			return null;
		}

		public String getxmleleprim(int index) {
			return null;
		}

		public int getxmlelevalueidx(int index) {
			return 0;
		}

		/** @deprecated
		 */
		public ch.interlis.iom.IomObject insertattrobj(
			String attrName,
			int index,
			String type) {
				Iom_jObject ret = null;
				if (attrv.containsKey(attrName))
				{
					// found, insert
					ArrayList valuev = (ArrayList)attrv.get(attrName);
					ret = new Iom_jObject(type, null);
					valuev.add(index,ret);
				}
				else
				{
					// not found, add
					ArrayList valuev = new ArrayList();
					ret = new Iom_jObject(type, null);
					valuev.add(index,ret);
					attrv.put(attrName, valuev);
				}
				return ret;
		}
		public void insertattrobj(
			String attrName,
			int index,
			ch.interlis.iom.IomObject obj) {
			if(obj==null){
				throw new IllegalArgumentException("illegal argument obj (=null)");
			}
				if (attrv.containsKey(attrName))
				{
					// found, insert
					ArrayList valuev = (ArrayList)attrv.get(attrName);
					valuev.add(index,obj);
				}
				else
				{
					// not found, add
					ArrayList valuev = new ArrayList();
					valuev.add(index,obj);
					attrv.put(attrName, valuev);
				}
		}

		public void setattrundefined(String attrName) {
			if (attrv.containsKey(attrName))
			{
				ArrayList valuev = (ArrayList)attrv.get(attrName);
				valuev.clear();
			}
			else
			{
				ArrayList valuev = new ArrayList();
				attrv.put(attrName, valuev);
			}
		}

		public void setattrvalue(String attrName, String value) 
		{
			if (attrv.containsKey(attrName))
			{
				ArrayList valuev = (ArrayList)attrv.get(attrName);
				valuev.clear();
				valuev.add(value);
			}
			else
			{
				ArrayList valuev = new ArrayList();
				valuev.add(value);
				attrv.put(attrName, valuev);
			}
		}

		private int consistency;
		public int getobjectconsistency() {
			return consistency;
		}
		public void setobjectconsistency(int consistency1) {
			consistency=consistency1;
		}

		private String oid;
		public String getobjectoid() {
			return oid;
		}
		public void setobjectoid(String oid1) {
			oid=oid1;
		}
		/*
		private string p_bid;
		public string objectbid
		{
			get { return p_bid; }
			set { p_bid = value; }
		}
		*/

		private int op;
		public int getobjectoperation() {
			return op;
		}
		public void setobjectoperation(int operation) {
			op=operation;
		}

		private String refbid;
		public String getobjectrefbid() {
			return refbid;
		}
		public void setobjectrefbid(String refbid1) {
			refbid=refbid1;
		}

		private String refoid;
		public String getobjectrefoid() {
			return refoid;
		}
		public void setobjectrefoid(String refoid1) {
			refoid=refoid1;
		}

		private long orderpos;
		public long getobjectreforderpos() {
			return orderpos;
		}
		public void setobjectreforderpos(long orderpos1) {
			orderpos=orderpos1;
		}

		private String tag;
		public String getobjecttag() {
			return tag;
		}
		public void setobjecttag(String tag1) {
			tag=tag1;
		}

		/** Returns a string representation of the object. Same as dumpObject().
		 */
		public String toString() {
			return dumpObject(this);
		}
		/** converts the contents of the given object for debuggung to a one line String.
		 * @param obj object to convert
		 * @return object as a String
		 */
		public static String dumpObject(ch.interlis.iom.IomObject obj)
		{
			StringBuffer ret=new StringBuffer();
			int i;
			ch.interlis.iom.IomObject structvalue;
			String value;
			String refoid;
			long orderPos;
			String className=obj.getobjecttag();
			String oid=obj.getobjectoid();
			ret.append(className);
			if(oid!=null){
				ret.append(" oid "+oid);
			}
			ret.append(" {");
			String sep="";
			for(i=0;i<obj.getattrcount();i++){
			   String propName=obj.getattrname(i);
			   value=obj.getattrvalue(propName);
			   if(value==null){
				  structvalue=obj.getattrobj(propName,0);
				  if(structvalue!=null){
						refoid=structvalue.getobjectrefoid();
						if(structvalue.getobjecttag()!=null){
							ret.append(sep+propName+" ");
							if(refoid!=null){
								orderPos=structvalue.getobjectreforderpos();
								if(orderPos!=0){
									ret.append("-> "+refoid+", ORDER_POS "+orderPos+" ");
								}else{
									ret.append("-> "+refoid+" ");
								}
							}
							ret.append(dumpObject(structvalue));
							if(refoid==null){
								int propc=obj.getattrvaluecount(propName);
								for(int propi=1;propi<propc;propi++){
									structvalue=obj.getattrobj(propName,propi);
									ret.append(", "+dumpObject(structvalue));
								}
							}
						}else if(refoid!=null){
							orderPos=structvalue.getobjectreforderpos();
							if(orderPos!=0){
								ret.append(sep+propName+" -> "+refoid+", ORDER_POS "+orderPos);
							}else{
								ret.append(sep+propName+" -> "+refoid);
							}
						}
						sep=", ";
				  }
			   }else{
				ret.append(sep+propName+" "+value);
				sep=", ";
			   }
			}
			ret.append("}");
			return ret.toString();
		}

}
